

#import "SLMeHeaderCollectionViewCell.h"
#import "SLUserCenterViewController.h"
#import "SLLoginVCViewController.h"

@interface SLMeHeaderCollectionViewCell()

@property (nonatomic, strong) UIImageView *bgImageView;

@property (nonatomic, strong) UIImageView *headView;//头像

@property (nonatomic, strong) UILabel *nameLabel;//名称

@property (nonatomic, strong) UILabel *loginTimeLabel;//登录时间

@property (nonatomic, strong) UIButton *setUpBtn;//设置

@property (nonatomic, strong) UIButton *loginBtn;//登录

@end

static const NSInteger btnTag = 888888;

@implementation SLMeHeaderCollectionViewCell

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self confignUI];
    }
    return self;
}


- (void)headViewClick
{
   
}

- (void)btnClick:(UIButton *)btn
{
    [self.viewController navPushViewController:[SLLoginVCViewController loadViewControllewWithNib] animated:YES];
}

- (void)setBtnClick:(UIButton *)btn
{
    [self.viewController navPushViewController:[SLUserCenterViewController loadViewControllewWithNib] animated:YES];
}

- (void)drawRect:(CGRect)rect
{
    
}

- (void)confignUI
{
    CGFloat bgHeight = (197 + kStatusBarHeight / 2) * KScaleW;
    CGFloat headOffsetY = -6;
    [self.bgImageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.equalTo(self.contentView);
        make.height.equalTo(@(bgHeight));
    }];
    
    [self.headView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(@(20));
        make.centerY.equalTo(self.bgImageView).offset(headOffsetY - 5);
        make.width.height.equalTo(@(52 * KScaleW));
    }];
    //
    [self.nameLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.headView);
        make.left.equalTo(self.headView.mas_right).offset(10 * KScaleW);
    }];
    
    [self.loginTimeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.nameLabel.mas_bottom).offset(7);
        make.left.equalTo(self.nameLabel.mas_left);
    }];
    

    [self.setUpBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.headView);
        make.right.equalTo(self.bgImageView.mas_right).offset(-20);
    }];
    
    UIImage *image = [UIImage gradientImageSize:CGSizeMake(kSCREEN_WIDTH, bgHeight) startPoint:CGPointMake(0, 0) endPoint:CGPointMake(0,bgHeight) colors:@[SLColor(@"#B2E8FF"), [SLColor(@"#B2E8FF") colorWithAlphaComponent:0.53],[SLColor(@"#B2E8FF") colorWithAlphaComponent:0.0],]];
    self.bgImageView.image = image;
    
    WS(weakSelf);
    [self.KVOController observe:[SLGlobalInfo SharedInstance] keyPath:@"loginInfo" options:NSKeyValueObservingOptionNew | NSKeyValueObservingOptionOld block:^(id  _Nullable observer, id  _Nonnull object, NSDictionary<NSKeyValueChangeKey,id> * _Nonnull change) {
        SLLoginInfo *targetModel = [SLGlobalInfo SharedInstance].loginInfo;
        if (targetModel) {
            weakSelf.nameLabel.text = [NSString stringWithFormat:@"Hi,%@",targetModel.user.name];
            weakSelf.loginTimeLabel.text = [NSString stringWithFormat:@"账号：%@",targetModel.user.phone];
            NSString *headUrl = [NSString stringWithFormat:@"%@%@",[SLHttpCenter SharedInstance].serverUrl, [SLGlobalInfo SharedInstance].loginInfo.user.head];
            [weakSelf.headView sd_setImageWithURL:[NSURL URLWithString:headUrl] placeholderImage:ImageName(@"icon_ellipse")];
        }else {
            weakSelf.nameLabel.text = @"尊敬的客户，您好！";
            weakSelf.loginTimeLabel.text = @"未登录";
            weakSelf.headView .image = ImageName(@"icon_ellipse");
        }
    }];
}

- (void)confignCellWithModel:(SLPageModel *)pageModel {
   
}

- (UIImageView *)bgImageView
{
    if (!_bgImageView) {
        _bgImageView = [[UIImageView alloc] initWithFrame:CGRectZero];
        _bgImageView.image = [UIImage imageNamed:@"icon_me_bg"];
        _bgImageView.userInteractionEnabled = YES;
        [self.contentView addSubview:_bgImageView];
    }
    return _bgImageView;
}

- (UIImageView *)headView
{
    if (!_headView) {
        _headView = [[UIImageView alloc] initWithFrame:CGRectZero];
        _headView.image = [UIImage imageNamed:@"icon_ellipse"];
        _headView.userInteractionEnabled = YES;
        CGFloat radius = 26;
        _headView.layer.cornerRadius = radius * KScaleW;
        _headView.clipsToBounds = YES;
        UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(headViewClick)];
        [_headView addGestureRecognizer:tap];
        [self.bgImageView addSubview:_headView];
    }
    return _headView;
}

- (UILabel *)loginTimeLabel
{
    if (!_loginTimeLabel) {
        _loginTimeLabel = [[UILabel alloc] initWithFrame:CGRectZero];
        _loginTimeLabel.font = [UIFont systemFontOfSize:16];
        _loginTimeLabel.textColor = SLColor(@"#8E8E93");
        _loginTimeLabel.text = @"未登录";
        [self.bgImageView addSubview:_loginTimeLabel];
    }
    return _loginTimeLabel;
}

- (UILabel *)nameLabel
{
    if (!_nameLabel) {
        _nameLabel = [[UILabel alloc] initWithFrame:CGRectZero];
        _nameLabel.font = [UIFont boldSystemFontOfSize:20];
        _nameLabel.textColor = SLColor(@"#080F1B");
        _nameLabel.text = @"尊敬的客户，您好！";
        [self.bgImageView addSubview:_nameLabel];
    }
    return _nameLabel;
}

- (UIButton *)setUpBtn
{
    if (!_setUpBtn) {
        _setUpBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [_setUpBtn addTarget:self action:@selector(setBtnClick:) forControlEvents:UIControlEventTouchUpInside];
        _setUpBtn.titleLabel.font = [UIFont systemFontOfSize:14];
        _setUpBtn.backgroundColor = UIColor.clearColor;
        _setUpBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
        [_setUpBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [_setUpBtn setImage:[UIImage imageNamed:@"icon_my_set"] forState:UIControlStateNormal];
        [self.bgImageView addSubview:_setUpBtn];
    }
    return _setUpBtn;
}

@end
