//
//  SLCreatMomentsVc.m
//  SLAiELTS
//
//  Created by Gusont on 2023/4/6.
//

#import "SLCreatMomentsVc.h"
#import "SLAddressBookVc.h"

#import "PlaceholderTextView.h"
#import "ZLPhotoBrowerView.h"
#import "SLRemidLookView.h"

#import "FriendInfoModel.h"

@interface SLCreatMomentsVc ()

@property (weak, nonatomic) IBOutlet PlaceholderTextView *textView;
@property (weak, nonatomic) IBOutlet ZLPhotoBrowerView *photoBrowerView;
@property (weak, nonatomic) IBOutlet SLRemidLookView *remidLookView;
@property (weak, nonatomic) IBOutlet UILabel *textNumberLabel;

@property (nonatomic, strong) NSMutableArray *photoBrowerModels;
@end

@implementation SLCreatMomentsVc

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.textView.placeholder = @"请输入...";
    self.photoBrowerView.maxSelectCount = 6;
    self.photoBrowerModels = [NSMutableArray array];
    self.photoBrowerView.dataArray = self.photoBrowerModels;
    WS(weakSelf);
    self.photoBrowerView.selectedData = ^(NSMutableArray<ZLPhotoBrowerModel *> *photoBrowerModels) {
        weakSelf.photoBrowerModels = photoBrowerModels;
    };
    
    YMBarButtonItem *rightBarItem = [[YMBarButtonItem alloc] initWithTitle:@"发布  " target:self action:@selector(preserveBtnClick)];
    rightBarItem.titleInsets = UIEdgeInsetsMake(0, 0, 0, 20);
    self.navigationBar.rightBarButtonItem = rightBarItem;
    [self.remidLookView.selBtn handleEvent:UIControlEventTouchUpInside withBlock:^{
        SLAddressBookVc *vc = [SLAddressBookVc loadViewControllewWithNib];
        vc.isSelFriend = YES;
        vc.selFriendsBlock = ^(NSArray *arr) {
            weakSelf.remidLookView.scrollView.contentSize = CGSizeMake(arr.count * 32, 32);
            [arr enumerateObjectsUsingBlock:^(FriendInfoModel *obj, NSUInteger idx, BOOL * _Nonnull stop) {
                UIImageView *imageView = [[UIImageView alloc] init];
                [imageView sd_setImageWithURL:[NSURL URLWithString:obj.photo] placeholderImage:[UIImage imageNamed:@"icon_ellipse"] completed:^(UIImage *image, NSError *error, SDImageCacheType cacheType, NSURL *imageURL) {
                    
                }];
                imageView.frame = CGRectMake(32 * idx, 0, 32, 32);
                [weakSelf.remidLookView.scrollView addSubview:imageView];
            }];
        };
        vc.title = @"发起群聊";
        [weakSelf navPushViewController:vc animated:YES];
    }];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text {
    NSString *toBeString = [textView.text stringByReplacingCharactersInRange:range withString:text];
    if (toBeString.length > 500) {
        return NO;
    }
    self.textNumberLabel.text = [NSString stringWithFormat:@"%ld/500",toBeString.length];
    return YES;
}

- (void)preserveBtnClick {
    
}

@end
