//
//  SDTimeLineTableHeaderView.m
//  GSD_WeiXin(wechat)
//
//  Created by gsd on 16/2/25.
//  Copyright © 2016年 GSD. All rights reserved.
//

/*
 
 *********************************************************************************
 *
 * GSD_WeiXin
 *
 * QQ交流群: 362419100(2群) 459274049（1群已满）
 * Email : gsdios@126.com
 * GitHub: https://github.com/gsdios/GSD_WeiXin
 * 新浪微博:GSD_iOS
 *
 * 此“高仿微信”用到了很高效方便的自动布局库SDAutoLayout（一行代码搞定自动布局）
 * SDAutoLayout地址：https://github.com/gsdios/SDAutoLayout
 * SDAutoLayout视频教程：http://www.letv.com/ptv/vplay/24038772.html
 * SDAutoLayout用法示例：https://github.com/gsdios/SDAutoLayout/blob/master/README.md
 *
 *********************************************************************************
 
 */

#import "SDTimeLineTableHeaderView.h"

#import "UIView+SDAutoLayout.h"

#import "SLCreatMomentsVc.h"

@implementation SDTimeLineTableHeaderView

{
    UIImageView *_backgroundImageView;
    UIImageView *_iconView;
    UILabel *_nameLabel;
    UIButton *_creatBtn;
    UIScrollView *_interestcrollView;
}

- (instancetype)initWithFrame:(CGRect)frame
{
    if (self = [super initWithFrame:frame]) {
        [self setup];
    }
    return self;
}

- (void)setup
{
    _backgroundImageView = [UIImageView new];
    _backgroundImageView.image = ImageName(@"icon_home_zysj");
    _backgroundImageView.userInteractionEnabled = YES;
    [self addSubview:_backgroundImageView];
    
    _iconView = [UIImageView new];
    _iconView.image = ImageName(@"icon_ellipse");
    [self addSubview:_iconView];
    
    _nameLabel = [UILabel new];
    _nameLabel.text = @"GSD_iOS";
    _nameLabel.textColor = [UIColor whiteColor];
    _nameLabel.textAlignment = NSTextAlignmentRight;
    _nameLabel.font = [UIFont boldSystemFontOfSize:15];
    [self addSubview:_nameLabel];
    
    _creatBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [_creatBtn setImage:ImageName(@"icon_pyq_more") forState:UIControlStateNormal];
    [_creatBtn addTarget:self action:@selector(creatBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:_creatBtn];
    
    _interestcrollView = [[UIScrollView alloc] initWithFrame:CGRectZero];
    _interestcrollView.bounces = NO;
    _interestcrollView.showsVerticalScrollIndicator = NO;
    _interestcrollView.showsHorizontalScrollIndicator = NO;
//    _interestcrollView.backgroundColor = [UIColor yellowColor];
    [self addSubview:_interestcrollView];
    
    NSMutableArray *marr = [NSMutableArray arrayWithArray:@[@"运动",@"运动",@"运动",@"运动"]];
    [marr enumerateObjectsUsingBlock:^(NSString *obj, NSUInteger idx, BOOL * _Nonnull stop) {
        UILabel *label = [[UILabel alloc] initWithFrame:CGRectZero];
        label.text = obj;
        label.frame = CGRectMake(60 * idx, 0, 48, 26);
        label.textColor = [UIColor whiteColor];
        label.font = [UIFont systemFontOfSize:10];
        label.backgroundColor = [[UIColor whiteColor] colorWithAlphaComponent:0.3];
        label.layer.cornerRadius = 13.0;
        label.textAlignment = NSTextAlignmentCenter;
        label.clipsToBounds = YES;
        [_interestcrollView addSubview:label];
    }];
    
    UIButton *moreInterestBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [moreInterestBtn setImage:ImageName(@"icon_moents_right_arrow") forState:UIControlStateNormal];
    WS(weakSelf);
    [moreInterestBtn handleEvent:UIControlEventTouchUpInside withBlock:^{
            
    }];
    [self addSubview:moreInterestBtn];
    
    
    _backgroundImageView.sd_layout.spaceToSuperView(UIEdgeInsetsMake(-60, 0, 40, 0));
    
    _iconView.sd_layout
    .widthIs(64)
    .heightIs(64)
    .leftSpaceToView(self, 16)
    .bottomSpaceToView(self, 94);
    
    
    _nameLabel.tag = 1000;
    [_nameLabel setSingleLineAutoResizeWithMaxWidth:200];
    _nameLabel.sd_layout
    .leftSpaceToView(_iconView, 9)
    .centerYEqualToView(_iconView)
    .heightIs(24);
    
    _interestcrollView.sd_layout
    .heightIs(26)
    .leftSpaceToView(self, 16)
    .rightSpaceToView(self, 50)
    .bottomSpaceToView(self, 54);
    
    _creatBtn.sd_layout
    .widthIs(36)
    .heightIs(36)
    .rightSpaceToView(self, 12)
    .topSpaceToView(self, 12);
    
    moreInterestBtn.sd_layout
    .widthIs(26)
    .heightIs(26)
    .rightSpaceToView(self, 12)
    .centerYEqualToView(_interestcrollView);
}

- (void)creatBtnClick {
    WS(weakSelf);
    [SLCustomizeAlert showBottomAletrWithTitles:@[@"拍照", @"从手机相册选择", @"纯文本"] cancelTitle:@"取消" buttonIndex:^(NSInteger index) {
        switch (index) {
            case 0:
            case 1:
            case 2:
            {
                SLCreatMomentsVc *vc = [SLCreatMomentsVc loadViewControllewWithNib];
                [weakSelf.viewController.rdv_tabBarController.navigationController pushViewController:vc animated:YES];
            }
                break;
            default:
                break;
        }
    }];
}

@end
